Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QLineF

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QLineF

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QLineF

extends QtJambiObject
implements java.lang.Cloneable

The `QLineF` class provides a two-dimensional vector using floating point precision. A `QLineF` describes a finite length line (or line segment) on a two-dimensional surface. `QLineF` defines the start and end points of the line using floating point accuracy for coordinates. Use the `toLine()` function to retrieve an integer based copy of this line.

The positions of the line's start and end points can be retrieved using the `p1()`, `x1()`, `y1()`, `p2()`, `x2()`, and `y2()` functions. The `dx()` and `dy()` functions return the horizontal and vertical components of the line, respectively.

The line's length can be retrieved using the `length()` function, and altered using the `setLength()` function. Similarly, `angle()` and `setAngle()` are respectively used for retrieving and altering the angle of the line. Use the `isNull()` function to determine whether the `QLineF` represents a valid line or a null line.

The `intersect()` function determines the `IntersectType` for this line and a given line, while the `angle()` function returns the angle between the lines. In addition, the `unitVector()` function returns a line that has the same starting point as this line, but with a length of only 1, while the `normalVector()` function returns a line that is perpendicular to this line with the same starting point and length.

Finally, the line can be translated a given offset using the `translate()` function, and can be traversed using the `pointAt()` function.

See also:
  `QLine`, `QPolygonF`, and `QRectF`.

Nested Class Summary
`static class` | `QLineF.IntersectType` Describes the intersection between two lines.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QLineF()` Constructs a null line.
`QLineF(double x1, double y1, double x2, double y2)` Constructs a line object that represents the line between (`x1`, `y1`) and (`x2`, `y2`).
`QLineF(QLine line)` Construct a `QLineF` object from the given integer-based `line`.
`QLineF(QPointF pt1, QPointF pt2)` Constructs a line object that represents the line between `p1` and `p2`.

Method Summary
`double` | `angle()` Returns the angle of the line in degrees.
`double` | `angle(QLineF l)` Returns the angle (in degrees) between this line and the given `line`, taking the direction of the lines into account.
`double` | `angleTo(QLineF l)` Returns the angle (in degrees) from this line to the given `line`, taking the direction of the lines into account.
`QLineF` | `clone()` This method is reimplemented for internal reasons
`double` | `dx()` Returns the horizontal component of the line's vector.
`double` | `dy()` Returns the vertical component of the line's vector.
`static QLineF` | `fromPolar(double length, double angle)` Returns a `QLineF` with the given `length` and `angle`.
`QLineF.IntersectType` | `intersect(QLineF line, QPointF intersectionPoint)` Returns a value indicating whether or not this line intersects with the given `line`.
`boolean` | `isNull()` Returns true if the line is not set up with valid start and end point; otherwise returns false.
`double` | `length()` Returns the length of the line.
`QLineF` | `normalVector()` Returns a line that is perpendicular to this line with the same starting point and length.
`QPointF` | `p1()` Returns the line's start point.
`QPointF` | `p2()` Returns the line's end point.
`QPointF` | `pointAt(double t)` Returns the point at the parameterized position specified by `t`.
`void` | `readFrom(QDataStream arg__1)` Reads a QLineF
`void` | `setAngle(double angle)` Sets the angle of the line to the given `angle` (in degrees).
`void` | `setLength(double len)` Sets the length of the line to the given `length`.
`void` | `setLine(double x1, double y1, double x2, double y2)` Sets this line to the start in `x1`, `y1` and end in `x2`, `y2`.
`void` | `setP1(QPointF p1)` Sets the starting point of this line to `p1`.
`void` | `setP2(QPointF p2)` Sets the end point of this line to `p2`.
`void` | `setPoints(QPointF p1, QPointF p2)` Sets the start point of this line to `p1` and the end point of this line to `p2`.
`QLine` | `toLine()` Returns an integer based copy of this line.
`java.lang.String` | `toString()` Returns a string representation of the `this QLineF`.
`void` | `translate(double dx, double dy)` Translates this line the distance specified by `dx` and `dy`.
`void` | `translate(QPointF p)` Translates this line by the given `offset`.
`QLineF` | `translated(double dx, double dy)` Returns this line translated the distance specified by `dx` and `dy`.
`QLineF` | `translated(QPointF p)` Returns this line translated by the given `offset`.
`QLineF` | `unitVector()` Returns the unit vector for this line, i.
`void` | `writeTo(QDataStream arg__1)` Writes thisQLineF
`double` | `x1()` Returns the x-coordinate of the line's start point.
`double` | `x2()` Returns the x-coordinate of the line's end point.
`double` | `y1()` Returns the y-coordinate of the line's start point.
`double` | `y2()` Returns the y-coordinate of the line's end point.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QLineF

    public QLineF()

  Constructs a null line.

### QLineF

    public QLineF(QLine line)

  Construct a `QLineF` object from the given integer-based `line`.

See also:
  `toLine()`.

### QLineF

    public QLineF(QPointF pt1,
                  QPointF pt2)

  Constructs a line object that represents the line between `p1` and `p2`.

### QLineF

    public QLineF(double x1,
                  double y1,
                  double x2,
                  double y2)

  Constructs a line object that represents the line between (`x1`, `y1`) and (`x2`, `y2`).

Method Detail

### angle

    public final double angle()

  Returns the angle of the line in degrees.

  Positive values for the angles mean counter-clockwise while negative values mean the clockwise direction. Zero degrees is at the 3 o'clock position.

See also:
  `setAngle()`.

### angle

    public final double angle(QLineF l)

  Returns the angle (in degrees) between this line and the given `line`, taking the direction of the lines into account. If the lines do not intersect within their range, it is the intersection point of the extended lines that serves as origin (see `QLineF::UnboundedIntersection` ).

  When the lines are parallel, this function returns 0 if they have the same direction; otherwise it returns 180.

See also:
  `intersect()`.

### angleTo

    public final double angleTo(QLineF l)

  Returns the angle (in degrees) from this line to the given `line`, taking the direction of the lines into account. If the lines do not intersect within their range, it is the intersection point of the extended lines that serves as origin (see `QLineF::UnboundedIntersection` ).

  The returned value represents the number of degrees you need to add to this line to make it have the same angle as the given `line`, going counter-clockwise.

See also:
  `intersect()`.

### dx

    public final double dx()

  Returns the horizontal component of the line's vector.

See also:
  `dy()`, and `pointAt()`.

### dy

    public final double dy()

  Returns the vertical component of the line's vector.

See also:
  `dx()`, and `pointAt()`.

### isNull

    public final boolean isNull()

  Returns true if the line is not set up with valid start and end point; otherwise returns false.

### length

    public final double length()

  Returns the length of the line.

See also:
  `setLength()`.

### normalVector

    public final QLineF normalVector()

  Returns a line that is perpendicular to this line with the same starting point and length.

See also:
  `unitVector()`.

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQLineF

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QLineF

### p1

    public final QPointF p1()

  Returns the line's start point.

See also:
  `setP1()`, `x1()`, `y1()`, and `p2()`.

### p2

    public final QPointF p2()

  Returns the line's end point.

See also:
  `setP2()`, `x2()`, `y2()`, and `p1()`.

### pointAt

    public final QPointF pointAt(double t)

  Returns the point at the parameterized position specified by `t`. The function returns the line's start point if t = 0, and its end point if t = 1.

See also:
  `dx()`, and `dy()`.

### setAngle

    public final void setAngle(double angle)

  Sets the angle of the line to the given `angle` (in degrees). This will change the position of the second point of the line such that the line has the given angle.

  Positive values for the angles mean counter-clockwise while negative values mean the clockwise direction. Zero degrees is at the 3 o'clock position.

See also:
  `angle()`.

### setLength

    public final void setLength(double len)

  Sets the length of the line to the given `length`. `QLineF` will move the end point - `p2()` - of the line to give the line its new length.

  If the line is a null line, the length will remain zero regardless of the length specified.

See also:
  `length()`, and `isNull()`.

### setLine

    public final void setLine(double x1,
                              double y1,
                              double x2,
                              double y2)

  Sets this line to the start in `x1`, `y1` and end in `x2`, `y2`.

See also:
  `setP1()`, `setP2()`, `p1()`, and `p2()`.

### setP1

    public final void setP1(QPointF p1)

  Sets the starting point of this line to `p1`.

See also:
  `setP2()`, and `p1()`.

### setP2

    public final void setP2(QPointF p2)

  Sets the end point of this line to `p2`.

See also:
  `setP1()`, and `p2()`.

### setPoints

    public final void setPoints(QPointF p1,
                                QPointF p2)

  Sets the start point of this line to `p1` and the end point of this line to `p2`.

See also:
  `setP1()`, `setP2()`, `p1()`, and `p2()`.

### toLine

    public final QLine toLine()

  Returns an integer based copy of this line.

  Note that the returned line's start and end points are rounded to the nearest integer.

See also:
  QLineF().

### translate

    public final void translate(QPointF p)

  Translates this line by the given `offset`.

### translate

    public final void translate(double dx,
                                double dy)

  Translates this line the distance specified by `dx` and `dy`.

### translated

    public final QLineF translated(QPointF p)

  Returns this line translated by the given `offset`.

### translated

    public final QLineF translated(double dx,
                                   double dy)

  Returns this line translated the distance specified by `dx` and `dy`.

### unitVector

    public final QLineF unitVector()

  Returns the unit vector for this line, i. a line starting at the same point as this line with a length of 1.0.

See also:
  `normalVector()`.

### x1

    public final double x1()

  Returns the x-coordinate of the line's start point.

See also:
  `p1()`.

### x2

    public final double x2()

  Returns the x-coordinate of the line's end point.

See also:
  `p2()`.

### y1

    public final double y1()

  Returns the y-coordinate of the line's start point.

See also:
  `p1()`.

### y2

    public final double y2()

  Returns the y-coordinate of the line's end point.

See also:
  `p2()`.

### fromPolar

    public static QLineF fromPolar(double length,
                                   double angle)

  Returns a `QLineF` with the given `length` and `angle`.

  The first point of the line will be on the origin.

  Positive values for the angles mean counter-clockwise while negative values mean the clockwise direction. Zero degrees is at the 3 o'clock position.

### intersect

    public final QLineF.IntersectType intersect(QLineF line,
                                                QPointF intersectionPoint)

  Returns a value indicating whether or not this line intersects with the given `line`.

  The actual intersection point is extracted to `intersectionPoint` (if the pointer is valid). If the lines are parallel, the intersection point is undefined.

### toString

    public java.lang.String toString()

  Returns a string representation of the `this QLineF`.

  Overrides:
    `toString` in class `java.lang.Object`

### clone

    public QLineF clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD